SoAccumulatedElement(3)

NAME
SoAccumulatedElement - The SoAccumulatedElement class is an abstract class for storing accumulated state.

SYNOPSIS

#include <Inventor/elements/SoAccumulatedElement.h>

Inherits SoElement.

Inherited by SoBumpMapMatrixElement, SoClipPlaneElement, SoLightElement, SoModelMatrixElement, SoMultiTextureMatrixElement, SoProfileElement, and SoVertexAttributeElement.

  Public Member Functions
virtual SbBool matches (const SoElement *element) const
Public Member Functions inherited from SoElement
const SoType getTypeId (void) const
int getStackIndex (void) const
virtual void pop (SoState *state, const SoElement *prevTopElement)
void setDepth (const int depth)
int getDepth (void) const
virtual void print (FILE *file=stdout) const
virtual ~SoElement ()

  Static Public Member Functions
static SoType getClassTypeId (void)
static int getClassStackIndex (void)
static void initClass (void)
Static Public Member Functions inherited from SoElement
static void initClass (void)
static SoType getClassTypeId (void)
static int getClassStackIndex (void)
static void initElements (void)
static int getNumStackIndices (void)
static SoType getIdFromStackIndex (const int stackIndex)

  Protected Member Functions
virtual ~SoAccumulatedElement ()
virtual void init (SoState *state)
virtual void push (SoState *state)
void clearNodeIds (void)
void addNodeId (const SoNode *const node)
void setNodeId (const SoNode *const node)
void copyNodeIds (const SoAccumulatedElement *copyfrom)
virtual SoElement * copyMatchInfo (void) const
virtual void captureThis (SoState *state) const
Protected Member Functions inherited from SoElement
SoElement (void)
void capture (SoState *const state) const
void setTypeId (const SoType typeId)
void setStackIndex (const int index)
SoElement * getNextInStack (void) const
SoElement * getNextFree (void) const

  Protected Attributes
SbList< SbUniqueId > nodeIds
Protected Attributes inherited from SoElement
SoType typeId
int stackIndex
int depth

  Additional Inherited Members
Static Protected Member Functions inherited from SoElement
static SoElement * getElement (SoState *const state, const int stackIndex)
static const SoElement * getConstElement (SoState *const state, const int stackIndex)
static int createStackIndex (const SoType id)
Static Protected Attributes inherited from SoElement
static int classStackIndex
static SoTypeList * stackToType

Detailed Description

The SoAccumulatedElement class is an abstract class for storing accumulated state. This is the superclass of elements where new element data accumulates with older data.

The element stores node id values for all nodes accumulated during traversal for the current state. These id values are used to determine when to invalidate caches.

See also
    SoReplacedElement, SoFloatElement, SoInt32Element

Constructor & Destructor Documentation

  SoAccumulatedElement::~SoAccumulatedElement (void ) [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoAccumulatedElement::getClassTypeId (void ) [static]
This static method returns the SoType object associated with objects of this class.

  int SoAccumulatedElement::getClassStackIndex (void ) [static]
This static method returns the state stack index for the class.

  void SoAccumulatedElement::initClass (void ) [static]
Initialize relevant common data for all instances, like the type system.

  SbBool SoAccumulatedElement::matches (const SoElement * element) const [virtual]
This function returns TRUE is the element matches another element (of the same class), with respect to cache validity.

If the application programmer's extension element has a matches() function, it should also have a copyMatchInfo() function.

Implements SoElement.

Reimplemented in SoModelMatrixElement.

  void SoAccumulatedElement::init (SoState * state) [protected], [virtual]
This function initializes the element type in the given SoState. It is called for the first element of each enabled element type in SoState objects.

Reimplemented from SoElement.

Reimplemented in SoBBoxModelMatrixElement, SoBumpMapMatrixElement, SoClipPlaneElement, SoGLClipPlaneElement, SoGLModelMatrixElement, SoGLMultiTextureMatrixElement, SoGLVertexAttributeElement, SoLightElement, SoModelMatrixElement, SoMultiTextureMatrixElement, SoProfileElement, and SoVertexAttributeElement.

  void SoAccumulatedElement::push (SoState * state) [protected], [virtual]
This method is called every time a new element is required in one of the stacks. This happens when a writable element is requested, using SoState::getElement() or indirectly SoElement::getElement(), and the depth of the current element is less than the state depth.

Override this method if your element needs to copy data from the previous top of stack. The push() method is called on the new element, and the previous element can be found using SoElement::getNextInStack().

Reimplemented from SoElement.

Reimplemented in SoBBoxModelMatrixElement, SoBumpMapMatrixElement, SoClipPlaneElement, SoGLModelMatrixElement, SoGLMultiTextureMatrixElement, SoLightElement, SoModelMatrixElement, SoMultiTextureMatrixElement, SoProfileElement, and SoVertexAttributeElement.

  void SoAccumulatedElement::clearNodeIds (void ) [protected]
Empty the list of node ids.

  void SoAccumulatedElement::addNodeId (const SoNode *const node) [protected]
Add the node id of node to the list of node ids.

  void SoAccumulatedElement::setNodeId (const SoNode *const node) [protected]
Empty the list of node ids, and add the id of node.

  void SoAccumulatedElement::copyNodeIds (const SoAccumulatedElement * copyfrom) [protected]
Convenience method which copies the node ids from copyfrom to this element.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

  SoElement * SoAccumulatedElement::copyMatchInfo (void ) const [protected], [virtual]
This function creates a copy of the element that contains enough information to enable the matches() function to work.

Used to help with scene graph traversal caching operations.

Implements SoElement.

  void SoAccumulatedElement::captureThis (SoState * state) const [protected], [virtual]
Adds the element to the cache.

Reimplemented from SoElement.

Member Data Documentation

  SbList<SbUniqueId> SoAccumulatedElement::nodeIds [protected]
Stores the internal list of node id values for nodes accumulated on the stack for the element.

Author

Generated automatically by Doxygen for Coin from the source code.